// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	アニメーションクラス
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	定数
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// アニメーション開始から完了までの時間（秒）
// 0.5以下だと不具合が発生する為、0.6以上で設定すること
const ANI_DUR_BASE					= 0.6;

// ■■ アニメーションディレイ（秒）
const ANI_DELY_INIT					= 0.5;		// 開始前に画像の読み込み時間を稼ぐ
const ANI_DELY_SECOND				= 0.5;
const ANI_DELY_THIRD				= 1.0;
const ANI_DELY_FOURTH				= 1.5;
const ANI_DELY_BOTTOM				= 1.0;

// 表示時のディレイ
const ANI_DELY_ON_BOX_TEAM			= ANI_DELY_INIT;
const ANI_DELY_ON_BOX_NOW			= ANI_DELY_INIT;
const ANI_DELY_ON_BOX_STAGE			= ANI_DELY_INIT + ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_STAR			= ANI_DELY_INIT + ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_EVENT			= ANI_DELY_INIT + ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_SCORE			= ANI_DELY_INIT + ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_LOGO			= ANI_DELY_INIT + ANI_DELY_THIRD;
const ANI_DELY_ON_BOX_BOTTOM		= ANI_DELY_INIT + ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_MEMBER		= ANI_DELY_INIT + ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_STAGE			= ANI_DELY_INIT + ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_TEAM			= ANI_DELY_INIT + ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_NOW			= ANI_DELY_INIT + ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_STAR			= ANI_DELY_INIT + ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_SCORE			= ANI_DELY_INIT + ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_EVENT			= ANI_DELY_INIT + ANI_DELY_THIRD;
const ANI_DELY_ON_MEMBER 			= ANI_DELY_INIT + ANI_DELY_THIRD + 0.1;
const ANI_DELY_ON_TXT_BOTTOM		= ANI_DELY_INIT + ANI_DELY_THIRD;

const ANI_DELY_OFF_BOX				= ANI_DELY_INIT + ANI_DELY_SECOND;
const ANI_DELY_OFF_TXT				= ANI_DELY_INIT;
const ANI_DELY_OFF_MEMBER			= ANI_DELY_INIT + ANI_DELY_SECOND;

const ANI_DELY_UPDATE				= ANI_DELY_INIT + ANI_DELY_SECOND;

// アニメーションの種類
const ANI_EASE_NONE					= "none";
const ANI_EASE_IN					= "power2.in";
const ANI_EASE_OUT					= "power2.out";
const ANI_EASE_INOUT				= "power2.inOut"
const ANI_BOUNCE_IN					= "bounce.in";
const ANI_BOUNCE_OUT				= "bounce.out";
const ANI_ELASTIC_OUT				= "elastic.out(2, 0.2)";
const ANI_BACK_OUT					= "back.out(4)";

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	文字列の調整
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
const SB_TXT_WIDTH_STINGER			= 1400;				// スティンガー内のチーム名
const SB_FONT_SIZE_STINGER			= 250;
const SB_FONT_SIZE_STINGER_MIN		= 100;

const SB_TXT_WIDTH_STINGER_VS		= 1100;				// スティンガー内の中央の「VS」
const SB_FONT_SIZE_STINGER_VS		= 250;
const SB_FONT_SIZE_STINGER_VS_MIN	= 50;

const SB_TXT_WIDTH_STINGER_NEXT		= 1400;				// スティンガー内の次戦カード
const SB_FONT_SIZE_STINGER_NEXT		= 250;
const SB_FONT_SIZE_STINGER_NEXT_MIN	= 40;

const SB_TXT_WIDTH_COMMENT_NAME		= 580;				// コメントの名前
const SB_FONT_SIZE_COMMENT_NAME		= 48;
const SB_FONT_SIZE_COMMENT_NAME_MIN	= 20;

const SB_TXT_WIDTH_WINNER			= 860;				// 勝利アニメーションの名前
const SB_FONT_SIZE_WINNER			= 160;
const SB_FONT_SIZE_WINNER_MIN		= 60;

class YmsbAnime {

	constructor(opacity, cssBox, cssTxt, vorhBox, moveBox, vorhTxt, moveTxt, delayBox, delayTxt) {
		this.currData	= "";
		this.moveTo		= ANI_MOVE_DEFAULT;
		this.opacity	= opacity;
		this.cssBox		= cssBox;
		this.cssTxt		= cssTxt;
		this.vorhBox	= vorhBox;
		this.vorhTxt	= vorhTxt;
		this.boxFrom	= moveBox;
		this.txtFrom	= moveTxt;
		this.delayBox	= delayBox;
		this.delayTxt	= delayTxt;
	}

	// 表示
	animeOn(newData) {
		if ("" != this.cssBox) {
			let pBoxFrom;
			let pBoxTo;
//			let flag = true;
			if (YMSB_VIRT == this.vorhBox) {
				pBoxFrom = {y:this.boxFrom, opacity:0.0};
				pBoxTo   = {y:this.moveTo,
					duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, delay:this.delayBox, opacity:this.opacity};
			}
			else {
				pBoxFrom = {x:this.boxFrom, opacity:0.0};
				pBoxTo   = {x:this.moveTo,
					duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, delay:this.delayBox, opacity:this.opacity};
			}
			gsap.timeline()
				.set(this.cssBox, pBoxFrom)
				.to (this.cssBox, pBoxTo);
		}

		if ("" != this.cssTxt) {
			let pTxtFrom;
			let pTxtTo;
			if (YMSB_VIRT == this.vorhTxt) {
				pTxtFrom = {y:this.txtFrom, opacity:0.0};
				pTxtTo   = {y:this.moveTo,
					duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, delay:this.delayTxt, opacity:this.opacity,
					onStart:YmsbAnime.callBackTextUpdate(this.cssTxt, newData)};
			}
			else {
				pTxtFrom = {x:this.txtFrom, opacity:0.0};
				pTxtTo   = {x:this.moveTo,
					duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, delay:this.delayTxt, opacity:this.opacity,
					onStart:YmsbAnime.callBackTextUpdate(this.cssTxt, newData)};
			}
			gsap.timeline()
				.set(this.cssTxt, pTxtFrom)
				.to (this.cssTxt, pTxtTo);
			this.currData = newData;
		}
	}

	// 非表示
	animeOff() {
		if ("" != this.cssBox) {
			let pBoxTo;
			if (YMSB_VIRT == this.vorhBox) {
				pBoxTo   = {y:this.boxFrom,
					duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_OFF_BOX, opacity:0.0};
			}
			else {
				pBoxTo   = {x:this.boxFrom,
					duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_OFF_BOX, opacity:0.0};
			}
			gsap.to (this.cssBox, pBoxTo);
		}

		if ("" != this.cssTxt) {
			let pTxtTo;
			if (YMSB_VIRT == this.vorhTxt) {
				pTxtTo   = {y:this.txtFrom,
					duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_OFF_TXT, opacity:0.0};
			}
			else {
				pTxtTo   = {x:this.txtFrom,
					duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_OFF_TXT, opacity:0.0};
			}
			gsap.to (this.cssTxt, pTxtTo);
			this.currData = "";
		}
	}
	
	// 更新
	animeUpdate(newData) {
		if ("" != this.cssTxt) {
			let pTxtOut;
			let pTxtIn;
			if (YMSB_VIRT == this.vorhTxt) {
				pTxtOut = {y:this.txtFrom, duration:ANI_DUR_BASE, ease:ANI_EASE_IN,  opacity:0.0, delay:ANI_DELY_UPDATE,
					onComplete:YmsbAnime.callBackTextUpdate(this.cssTxt, newData)};
				pTxtIn  = {y:this.moveTo,  duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, opacity:this.opacity,};
			}
			else {
				pTxtOut = {x:this.txtFrom, duration:ANI_DUR_BASE, ease:ANI_EASE_IN,  opacity:0.0, delay:ANI_DELY_UPDATE,
					onComplete:YmsbAnime.callBackTextUpdate(this.cssTxt, newData)};
				pTxtIn  = {x:this.moveTo,  duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, opacity:this.opacity};
			}
			gsap.timeline()
				.to(this.cssTxt, pTxtOut)
				.to(this.cssTxt, pTxtIn);
			this.currData = newData;
		}
	}

	// ■■ テキスト更新コールバック
	static callBackTextUpdate(cssName, strText) {
		return () => {
			jQuery(cssName).textWithLF(YmsbAnime.fitTextWidth(strText, cssName));
		};
	}

	// ■■ テキストの長さに合わせてフォントサイズを変更する ■■
	static fitTextWidth(text,id) {
		let viewText = new String(text);
		let viewFontSize;
		let minFontSize;
		let maxTxtSize;
		let maxOmit = 0;

		switch (id) {
			case SbCSS.TXT_TEAM_1P:
			case SbCSS.TXT_TEAM_2P:
				viewFontSize	= SB_FONT_SIZE_TEAM;
				minFontSize		= SB_FONT_SIZE_TEAM_MIN;
				maxTxtSize		= SB_TXT_WIDTH_TEAM;
				maxOmit			= SB_TXT_WIDTH_TEAM_OMIT;
				break;

			case SbCSS.TXT_STAGE:
				viewFontSize	= SB_FONT_SIZE_STAGE;
				minFontSize		= SB_FONT_SIZE_STAGE_MIN;
				maxTxtSize		= SB_TXT_WIDTH_STAGE;
				maxOmit			= maxTxtSize;
				break;

			case SbCSS.TXT_EVENT_01:
			case SbCSS.TXT_EVENT_02:
				viewFontSize	= SB_FONT_SIZE_EVENT;
				minFontSize		= SB_FONT_SIZE_EVENT_MIN;
				maxTxtSize		= SB_TXT_WIDTH_EVENT;
				maxOmit			= maxTxtSize;
				break;

			case SbCSS.TXT_NOW_1P:
			case SbCSS.TXT_NOW_2P:
				viewFontSize	= SB_FONT_SIZE_NOW;
				minFontSize		= SB_FONT_SIZE_NOW_MIN;
				maxTxtSize		= SB_TXT_WIDTH_NOW;
				maxOmit			= maxTxtSize;
				break;

			case SbCSS.TXT_FT10_NAME_1P:
			case SbCSS.TXT_FT10_NAME_2P:
				viewFontSize	= SB_FONT_SIZE_FT10NAME;
				minFontSize		= SB_FONT_SIZE_FT10NAME_MIN;
				maxTxtSize		= SB_TXT_WIDTH_FT10NAME;
				maxOmit			= maxTxtSize;
				break;

			case SbCSS.TXT_STINGER_1P:
			case SbCSS.TXT_STINGER_2P:
			case SbCSS.TXT_STINGER_EVENT:
				viewFontSize	= SB_FONT_SIZE_STINGER;
				minFontSize		= SB_FONT_SIZE_STINGER_MIN;
				maxTxtSize		= SB_TXT_WIDTH_STINGER;
				maxOmit			= maxTxtSize;
				break;

			case SbCSS.TXT_STINGER_NEXT_1P:
			case SbCSS.TXT_STINGER_NEXT_2P:
				viewFontSize	= SB_FONT_SIZE_STINGER_NEXT;
				minFontSize		= SB_FONT_SIZE_STINGER_NEXT_MIN;
				maxTxtSize		= SB_TXT_WIDTH_STINGER_NEXT;
				maxOmit			= maxTxtSize * 2;
				break;

			case SbCSS.TXT_STINGER_VS:
				viewFontSize	= SB_FONT_SIZE_STINGER_VS;
				minFontSize		= SB_FONT_SIZE_STINGER_VS_MIN;
				maxTxtSize		= SB_TXT_WIDTH_STINGER_VS;
				maxOmit			= maxTxtSize;
				break;

			case SbCSS.TXT_COMMENT_NAME_1P:
			case SbCSS.TXT_COMMENT_NAME_2P:
				viewFontSize	= SB_FONT_SIZE_COMMENT_NAME;
				minFontSize		= SB_FONT_SIZE_COMMENT_NAME_MIN;
				maxTxtSize		= SB_TXT_WIDTH_COMMENT_NAME;
				maxOmit			= maxTxtSize;
				break;

			case SbCSS.TXT_MEMBER_1P_01:
			case SbCSS.TXT_MEMBER_1P_02:
			case SbCSS.TXT_MEMBER_1P_03:
			case SbCSS.TXT_MEMBER_1P_04:
			case SbCSS.TXT_MEMBER_1P_05:
			case SbCSS.TXT_MEMBER_1P_06:
			case SbCSS.TXT_MEMBER_1P_07:
			case SbCSS.TXT_MEMBER_1P_08:
			case SbCSS.TXT_MEMBER_1P_09:
			case SbCSS.TXT_MEMBER_1P_10:
			case SbCSS.TXT_MEMBER_1P_11:
			case SbCSS.TXT_MEMBER_1P_12:
			case SbCSS.TXT_MEMBER_1P_13:
			case SbCSS.TXT_MEMBER_1P_14:
			case SbCSS.TXT_MEMBER_1P_15:
			case SbCSS.TXT_MEMBER_1P_16:
			case SbCSS.TXT_MEMBER_1P_17:
			case SbCSS.TXT_MEMBER_1P_18:
			case SbCSS.TXT_MEMBER_2P_01:
			case SbCSS.TXT_MEMBER_2P_02:
			case SbCSS.TXT_MEMBER_2P_03:
			case SbCSS.TXT_MEMBER_2P_04:
			case SbCSS.TXT_MEMBER_2P_05:
			case SbCSS.TXT_MEMBER_2P_06:
			case SbCSS.TXT_MEMBER_2P_07:
			case SbCSS.TXT_MEMBER_2P_08:
			case SbCSS.TXT_MEMBER_2P_09:
			case SbCSS.TXT_MEMBER_2P_10:
			case SbCSS.TXT_MEMBER_2P_11:
			case SbCSS.TXT_MEMBER_2P_12:
			case SbCSS.TXT_MEMBER_2P_13:
			case SbCSS.TXT_MEMBER_2P_14:
			case SbCSS.TXT_MEMBER_2P_15:
			case SbCSS.TXT_MEMBER_2P_16:
			case SbCSS.TXT_MEMBER_2P_17:
			case SbCSS.TXT_MEMBER_2P_18:
				viewFontSize	= SB_FONT_SIZE_MEMBER;
				minFontSize		= SB_FONT_SIZE_MEMBER_MIN;
				maxTxtSize		= SB_TXT_WIDTH_MEMBER;
				maxOmit			= maxTxtSize;
				break;

			case SbCSS.TXT_WINNER:
				viewFontSize 	= SB_FONT_SIZE_WINNER;
				minFontSize		= SB_FONT_SIZE_WINNER_MIN;
				maxTxtSize		= SB_TXT_WIDTH_WINNER;
				maxOmit			= maxTxtSize * 4;
				break;

			default:
				return viewText;
		}

		// 指定サイズより文字列長が短くなるまでフォントサイズを調整する
		//	let canvas = document.createElement("canvas");
		let canvas = document.getElementById("scMeasureText");
		let context = canvas.getContext("2d");
		let metrics;
		let nWidth;
		do {
			if (minFontSize > viewFontSize) break;
			viewFontSize --;
			context.font = viewFontSize + "px " + arrFonts[cFont.FONT_NAME][currFont];
			metrics = context.measureText(viewText);
			nWidth = metrics.width;
		} while (nWidth >= maxTxtSize);

		let setFontSize = viewFontSize + "px";
		jQuery(id).css({"font-size":setFontSize, "line-height":setFontSize});

		// 改行を許せる場合は改行し文字列長を調整した上で省略文字を付加する
		if (minFontSize > viewFontSize) {
			let flagWrap = false;
			while (maxOmit < nWidth){
				viewText = viewText.slice(0, viewText.length - 1);
				context.font = viewFontSize + "px " + arrFonts[cFont.FONT_NAME][currFont];
				metrics = context.measureText(viewText);
				nWidth = metrics.width;
				flagWrap = true;
			}
			if (flagWrap) {
				viewText = viewText.slice(0, viewText.length - 1);
				viewText += SB_TXT_OMIT;
			}
		}
		if (maxTxtSize != maxOmit) {
			jQuery(id).css({"white-space":"normal"});
		}
		else {
			jQuery(id).css({"white-space":"nowrap"});
		}
/*
		if ((0 != maxOmit) && (minFontSize > viewFontSize)) {
			let flagWrap = false;
			while (maxOmit < nWidth){
				viewText = viewText.slice(0, viewText.length - 1);
				context.font = viewFontSize + "px " + arrFonts[cFont.FONT_NAME][currFont];
				metrics = context.measureText(viewText);
				nWidth = metrics.width;
				flagWrap = true;
			}
			if (flagWrap) {
				viewText = viewText.slice(0, viewText.length - 1);
				viewText += SB_TXT_OMIT;
			}
			jQuery(id).css({"white-space":"pre-wrap"});
		}
		else {
			jQuery(id).css({"white-space":"nowrap"});
		}
*/
		return viewText;
	}
}
