// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	イベント名の更新・アニメーション表示
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ イベント名クラス
class YmsbEventCheck extends YmsbCheck {

	EVENT_OFF    = 0;
	EVENT_TOP    = 1;
	EVENT_BOTTOM = 2;

	constructor(moveBoxTop, moveTxtTop, moveBoxBottom, moveTxtBottom) {
		super();
		this.eventTop		= new YmsbAnime(1.0, SbCSS.BOX_EVENT_01, SbCSS.TXT_EVENT_01,
								YMSB_VIRT, moveBoxTop, YMSB_VIRT, moveTxtTop,
								ANI_DELY_ON_BOX_EVENT, ANI_DELY_ON_TXT_EVENT);
		this.eventBottom	= new YmsbAnime(1.0, SbCSS.BOX_EVENT_02, SbCSS.TXT_EVENT_02,
								YMSB_VIRT, moveBoxBottom, YMSB_VIRT, moveTxtBottom,
								ANI_DELY_ON_BOX_EVENT, ANI_DELY_ON_TXT_EVENT);
		this.currState		= YMSB_OFF;
		this.currData		= "";
	}

	// データ切り分け
	checkData() {
		let newState = jsonData[SbJSON.EVENT_SWITCH];
		let newData  = jsonData[SbJSON.EVENT_NAME];	

		if (
			(YMSB_OFF_ON == currScoreBoard && this.EVENT_OFF != newState && "" != newData)
		) {
			if  (this.EVENT_TOP    == newState) {
				this.eventTop.animeOn(newData);
			}
			else if
				(this.EVENT_BOTTOM == newState) {
				this.eventBottom.animeOn(newData);
			}
			else {
				// nop
			}
		}
		else if (
			(YMSB_ON_OFF == currScoreBoard && "" != this.currData)
		) {
			if  (this.EVENT_TOP    == newState) {
				this.eventTop.animeOff();
			}
			else if
				(this.EVENT_BOTTOM == newState) {
				this.eventBottom.animeOff();
			}
			else {
				// nop
			}
		}
		else if (
			(YMSB_ON == currScoreBoard)
		) {
			if (
				(this.EVENT_BOTTOM == this.currState && "" != this.currData && "" != newData && this.EVENT_OFF == newState) 
			||  (this.EVENT_BOTTOM == this.currState && "" != this.currData && "" == newData)
			) {
				this.eventBottom.animeOff();
				newData = "";
				newState = this.EVENT_OFF;
			}
			else if (
				(this.EVENT_TOP == this.currState && "" != this.currData && "" != newData && this.EVENT_OFF == newState) 
			||  (this.EVENT_TOP == this.currState && "" != this.currData && "" == newData)
			) {
				this.eventTop.animeOff();
				newData = "";	
				newState = this.EVENT_OFF;
			}
			else if (
				(this.EVENT_BOTTOM == newState && "" == this.currData && "" != newData)
			||  (this.EVENT_BOTTOM == newState && "" != this.currData && "" != newData && this.EVENT_OFF == this.currState)
			) {
				this.eventBottom.animeOn(newData);
			}
			else if (
				(this.EVENT_TOP == newState && "" == this.currData && "" != newData)
			||  (this.EVENT_TOP == newState && "" != this.currData && "" != newData && this.EVENT_OFF == this.currState)
			) {
				this.eventTop.animeOn(newData);
			}
			else if (
				(this.EVENT_TOP == newState && this.EVENT_BOTTOM == this.currState && "" != this.currData && "" != newData)
			) {
				this.eventBottom.animeOff();
				this.eventTop.animeOn(newData);
			}
			else if (
				(this.EVENT_BOTTOM == newState && this.EVENT_TOP == this.currState && "" != this.currData && "" != newData)
			) {
				this.eventTop.animeOff();
				this.eventBottom.animeOn(newData);
			}
			else if (
				(newState == this.currState && this.currData != newData && "" != this.currData && "" != newData)
			) {
				if (this.EVENT_BOTTOM == newState) {
					this.eventBottom.animeUpdate(newData);
				}
				else if (this.EVENT_TOP == newState) {
					this.eventTop.animeUpdate(newData);
				}
				else {
					// nop
				}
			}
			else {
				// nop
			}
		}
		this.currData = newData;
		this.currState = newState;
	}
}