// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	団体戦メンバーの更新チェック
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ 団体戦の対戦中メンバー
const YMSB_NOW_PLAYING				= 2;

class YmsbMemberCheck extends YmsbCheck {

	arrMemberNum	= [];
	arrMember		= [];
	arrMemberLife	= [];
	arrSideLives	= [];
	arrSideDeads	= [];
	arrMoveSide		= [YMSB_RIGHT, YMSB_LEFT];

	constructor(fixHeight) {
		super();
		this.currHide 			= YMSB_OFF;
		this.currFixHeight		= fixHeight;
		this.currBottomSize		= BOTTOM_SIZE_SHORT;
		this.currMaxLives		= 0;
		this.lifeHeight			= 30;
		for (let i = 0; i < 2; i++) {
			this.arrMemberNum[i]	= 0;
			this.arrSideLives[i]	= 0;
			this.arrSideDeads[i]	= 0;
			this.arrMember[i]		= [];
			this.arrMemberLife[i]	= [];
			for (let j = 0; j < YMSB_MAX_PLAYER; j++) {
				this.arrMember[i][j]		= new YmsbMember(i, j, 
					arrBoxMemberCSS[i][j],     arrTxtMemberCSS[i][j],     YMSB_OFF, 0.7);
				this.arrMemberLife[i][j]	= new YmsbMember(i, j, 
					arrBoxMemberLifeCSS[i][j], arrTxtMemberLifeCSS[i][j], YMSB_OFF, 1.0);
			}
		}
	}

	// データ切り分け
	checkData() {
		let newHide 		= jsonData[SbJSON.HIDE_MEMBER];
		let newFixHeight	= jsonData[SbJSON.FIX_MEMBER_HEIGHT];
		let newBottomSize	= jsonData[SbJSON.BOTTOM_SIZE]
		let newMemberNum	= [];
		let memberHeight    = [];
		let memberTop 		= [];
		let newMaxLives		= jsonData[SbJSON.MAX_MEMBER_LIVES];

		// memo
		// 団体戦ライフ０かつライフ連動の場合は相手Dead数をポイント表示させる
		// メンバ変数でSidePointを定義、ローカル変数SideDeadでDead数をカウントし、ループ後に入れ替える

		// メンバー数と枠の高さを設定
		for (let i = 0; i < 2; i++) {
			newMemberNum[i]			= 0;
			this.arrSideLives[i]	= 0;
			this.arrSideDeads[i]	= 0;
			let flagMaxMember = YMSB_OFF;

			for (let j = YMSB_MAX_PLAYER - 1; j >= 0 ; j--) {

				if ("" != jsonData[arrTxtMemberJSON[i][j]]) {
					if (YMSB_ON != flagMaxMember) {
						flagMaxMember = YMSB_ON;
						newMemberNum[i] = j + 1;
					}
					if (YMSB_ON == jsonData[arrPrmDeadJSON[i][j]]) {
						this.arrSideDeads[i] ++;
					}
					else {
						this.arrSideLives[i] += parseInt(jsonData[arrPrmLifeJSON[i][j]]);
					}
				}
			}
			if (0 < newMemberNum[i]) {
				if (YMSB_OFF != newFixHeight && newMemberNum[i] <= YMSB_MAX_FIX_MEMBER) {
					memberHeight[i] = YMSB_FIX_MEMBER_HEIGHT;
					memberTop[i]	= memberHeight[i] + ((arrBottomSize[newBottomSize][BOTTOM_SIZE_MAX_HEIGHT] - (YMSB_FIX_MEMBER_HEIGHT * newMemberNum[i])) / (newMemberNum[i] - 1));
					// 高さ + (全体 - (高さ*人数) / (人数 - 1))
				}
				else if (newMemberNum[i] <= YMSB_MAX_FIX_MEMBER) {
					memberHeight[i] = YMSB_FIX_MEMBER_HEIGHT;
					memberTop[i]	= memberHeight[i];
				}
				else {
					memberHeight[i] = arrBottomSize[newBottomSize][BOTTOM_SIZE_MAX_HEIGHT] / newMemberNum[i];
					memberTop[i]	= memberHeight[i];
				}
			}
		}

		for (let i = 0; i < 2; i++) {
			let newOrder = jsonData[arrJSONOrder[i]] - 1;

			for (let j = 0; j < YMSB_MAX_PLAYER; j++) {
				let newData = jsonData[arrTxtMemberJSON[i][j]];
				let newDead = jsonData[arrPrmDeadJSON[i][j]];
				let newLife = jsonData[arrPrmLifeJSON[i][j]];
				let newBack = "";
				if ((arrPrmMemberBackJSON[i].length > j) && (newMemberNum[i] <= YMSB_MAX_FIX_MEMBER)){
					newBack = jsonData[arrPrmMemberBackJSON[i][j]];
				}

				if (newOrder == j) {
					newDead = YMSB_NOW_PLAYING;	
				}
				else if (0 == newLife && 0 != newMaxLives) {
					newDead = YMSB_ON;
				}
				else {
					// nop
				}

				// メンバー表示
				let cssPropTxt 		= this.setCssPropTxt(newDead, i, j, memberHeight[i], memberTop[i], newBack);
				let cssPropBox 		= this.setCssPropBox(newDead, i, j, memberHeight[i], memberTop[i], newBack);
				let cssPropTxtLife 	= this.setCssPropTxtLife(newDead, j, memberTop[i]);
				let cssPropBoxLife 	= this.setCssPropBoxLife(newDead, i, j, memberHeight[i], memberTop[i]);

				if (
					(YMSB_OFF_ON == currScoreBoard && YMSB_OFF == newHide && "" != newData)
				||  (YMSB_ON     == currScoreBoard && YMSB_ON  == this.currHide && YMSB_OFF == newHide && "" != newData)
				||  (YMSB_ON     == currScoreBoard && YMSB_OFF == this.currHide && YMSB_OFF == newHide && "" != newData && "" == this.arrMember[i][j].currData)
				) {
					this.arrMember[i][j].animeOn(newData, cssPropTxt, cssPropBox);
					if (0 != newMaxLives) {
						this.arrMemberLife[i][j].animeOn(newLife, cssPropTxtLife, cssPropBoxLife);
					}
				}
				else if (
					(YMSB_ON_OFF == currScoreBoard && YMSB_OFF == this.currHide && "" != this.arrMember[i][j].currData)
				||  (YMSB_ON     == currScoreBoard && YMSB_OFF == this.currHide && YMSB_ON  == newHide && "" != this.arrMember[i][j].currData)
				||  (YMSB_ON     == currScoreBoard && YMSB_OFF == this.currHide && YMSB_OFF == newHide && "" != this.arrMember[i][j].currData && "" == newData)
				) {
					this.arrMember[i][j].animeOff();
					if (0 != this.currMaxLives) {
						this.arrMemberLife[i][j].animeOff();
					}
				}
				else if (
					((YMSB_ON == currScoreBoard && YMSB_OFF == this.currHide && YMSB_OFF == newHide)
					&&	("" != this.arrMember[i][j] && "" != newData)
					&&	(this.arrMember[i][j].currData != newData || this.arrMember[i][j].pDead != newDead))
				||	(YMSB_ON == currScoreBoard && YMSB_OFF == newHide) 
					&&	(("" != newData) && ((this.currFixHeight != newFixHeight) 
											|| (this.arrMemberNum[i] != newMemberNum[i])
											|| (this.currBottomSize != newBottomSize))
						)
				) {
					this.arrMember[i][j].animeUpdate(newData, cssPropTxt, cssPropBox);
					if 		(0 == this.currMaxLives && 0 != newMaxLives) {
						this.arrMemberLife[i][j].animeOn(newLife, cssPropTxtLife, cssPropBoxLife);
					}
					else if (0 != this.currMaxLives && 0 == newMaxLives) {
						this.arrMemberLife[i][j].animeOff();
					}
					else if (0 != this.currMaxLives && 0 != newMaxLives) {
						this.arrMemberLife[i][j].animeUpdate(newLife, cssPropTxtLife, cssPropBoxLife);
					}
					else {
						// nop
					}
				}
				else if (
					(YMSB_ON == currScoreBoard && YMSB_OFF == this.currHide && YMSB_OFF == newHide)
				&&	("" != this.arrMember[i][j].currData && "" != newData)
				) {
					if 		(0 == this.currMaxLives && 0 != newMaxLives) {
						this.arrMemberLife[i][j].animeOn(newLife, cssPropTxtLife, cssPropBoxLife);
					}
					else if (0 != this.currMaxLives && 0 == newMaxLives) {
						this.arrMemberLife[i][j].animeOff();
					}
					else if (0 != newMaxLives && newLife != this.arrMemberLife[i][j].currData) {
						this.arrMemberLife[i][j].animeUpdate(newLife, cssPropTxtLife, cssPropBoxLife);
					}
					else {
						// nop
					}
				}
				else {
					// nop
				}

				this.arrMember[i][j].currData		= newData;
				this.arrMember[i][j].pDead			= newDead;
				this.arrMemberLife[i][j].currData	= newLife;
			}
			this.arrMemberNum[i] = newMemberNum[i];
		}
		this.currFixHeight 	= newFixHeight;
		this.currHide 		= newHide;
		this.currBottomSize = newBottomSize;
		this.currMaxLives	= newMaxLives;
	}

	// CSSプロパティ設定（テキスト）
	setCssPropTxt(newDead, side, number, memberHeight, memberTop, newBack) {
		const arrJustify = ["end", "start"];
		let fontColor;
		let fontShadow = "1px 1px 2px ";
		if (YMSB_ON == newDead){
			fontColor  = cSkin.FONT_COLOR_MEM_LOS;
			fontShadow += cSkin.FONT_SHADE_MEM_LOS;
		}
		else if (YMSB_NOW_PLAYING == newDead){
			fontColor  = cSkin.FONT_COLOR_MEM_WIN;
			fontShadow += cSkin.FONT_SHADE_MEM_NOW;
		}
		else {
			fontColor  = cSkin.FONT_COLOR_MEM_WIN;
			fontShadow += cSkin.FONT_SHADE_MEM_WIN;
		}

		let alighItems		= "center";
		let justifyContent	= "center";
		if ("" != newBack) {
			alighItems		= "end";
			justifyContent	= arrJustify[side];
		}

		let cssPropTxt = {
			"top"				: YMSB_MEMBER_POSITION_TOP + number * memberTop,
			"height"			: memberHeight - 5,
			"color"				: fontColor,
			"text-shadow"		: fontShadow,
			"align-items"		: alighItems,
			"justify-content"	: justifyContent
		};
		return cssPropTxt;
	}
	setCssPropTxtLife(newDead, number, memberTop) {
		let fontColor;
		let fontShadow;
		if (YMSB_ON == newDead){
			fontColor  = cSkin.FONT_COLOR_MEM_LOS;
			fontShadow = cSkin.FONT_SHADE_MEM_LOS;
		}
		else if (YMSB_NOW_PLAYING == newDead){
			fontColor  = cSkin.FONT_COLOR_MEM_WIN;
			fontShadow = cSkin.FONT_SHADE_MEM_NOW;
		}
		else {
			fontColor  = cSkin.FONT_COLOR_MEM_WIN;
			fontShadow = cSkin.FONT_SHADE_MEM_WIN;
		}

		let cssPropTxt = {
			"top"			: YMSB_MEMBER_POSITION_TOP + number * memberTop,
			"height"		: this.lifeHeight,
			"color"			: fontColor,
			"text-shadow"	: fontShadow + " 0 0 10px;"
		};
		return cssPropTxt;
	}

	// CSSプロパティ設定（背景）
	setCssPropBox(newDead, side, number, memberHeight, memberTop, newBack) {
		let bgColor;
		let bgBorder;
		let bgBlend = "normal";
		if (YMSB_ON == newDead){
			bgColor		= cSkin.BG_COLOR_MEM_LOS;
			bgBorder	= arrSkin[cSkin.arrColorMemberBorder[side]][currSkin];
			bgBlend		= "luminosity";
		}
		else if (YMSB_NOW_PLAYING == newDead){
			bgColor		= arrSkin[cSkin.arrColorMemberBox[side]][currSkin];
			bgBorder	= arrSkin[cSkin.arrColorMemberBoxNow[side]][currSkin];
		}
		else {
			bgColor 	= arrSkin[cSkin.arrColorMemberBox[side]][currSkin];
			bgBorder	= arrSkin[cSkin.arrColorMemberBorder[side]][currSkin];
		}
		let bgBorderSide   = cSkin.PARAM_BORDER_SIDE   + bgBorder;
		let bgBorderBottom = cSkin.PARAM_BORDER_BOTTOM + bgBorder;

		if ("" != newBack) {
			newBack = YMSB_URL_USER + newBack + ".png";
		}

		let cssPropBox = {
			"top"				: YMSB_MEMBER_POSITION_TOP + number * memberTop,
			"height"			: memberHeight - 5,
			"background-color"	: bgColor,
			"background-image"	: "url(" + newBack  + ")",
			"background-blend-mode" : bgBlend,
			"border-bottom"   	: bgBorderBottom,
			"border-left"     	: bgBorderSide,
			"border-right"    	: bgBorderSide
		};
		return cssPropBox;
	}
	setCssPropBoxLife(newDead, side, number, memberHeight, memberTop) {
		let bgColor;
		let bgBorder;
		if (YMSB_ON == newDead){
			bgColor    = cSkin.BG_COLOR_MEM_LOS;
			bgBorder   = arrSkin[cSkin.arrColorMemberBorder[side]][currSkin];
		}
		else if (YMSB_NOW_PLAYING == newDead){
			bgColor    = arrSkin[cSkin.arrColorMemberBox[side]][currSkin];
			bgBorder   = arrSkin[cSkin.arrColorMemberBoxNow[side]][currSkin];
		}
		else {
			bgColor    = arrSkin[cSkin.arrColorMemberBox[side]][currSkin];
			bgBorder   = arrSkin[cSkin.arrColorMemberBorder[side]][currSkin];
		}
		let bgBorderParam  = cSkin.PARAM_BORDER_BOTTOM + bgBorder;

		let cssPropBox = {
			"top"				: YMSB_MEMBER_POSITION_TOP + number * memberTop,
			"height"			: this.lifeHeight,
			"background-color"	: bgColor,
			"border"			: bgBorderParam
		};
		return cssPropBox;
	}

	// ■■ （スコア設定用）全体のライフを取得
	getSideLives() {
		return this.arrSideLives;
	}

	getSideDeads() {
		return this.arrSideDeads;
	}
}